package ar.edu.unju.fi.controller;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;
import ar.edu.unju.fi.model.Post;

@Controller
@RequestMapping("/demoSpring")
public class PostController {
	Logger logger = LoggerFactory.getLogger(PostController.class);
	
	public List<Post> getPosts(){
		List<Post> listaPosts = new ArrayList<>();
		listaPosts.add(new Post(1,"Descripción de un bootcamp para el desarrollo de BD Relacionales","image01.jpg",LocalDate.now(),"Curso BD Relacionales"));
		listaPosts.add(new Post(2,"Descripción de un bootcamp para el desarrollo de Aplicaciones web con Spring Boot","image02.jpg",LocalDate.now(),"Curso Spring Boot"));
		listaPosts.add(new Post(3,"Descripción de un bootcamp para el desarrollo de Videojuegos con Unity","image03.jpg",LocalDate.now(),"Curso Unity 3D"));
		return listaPosts;
	}
	
    @GetMapping("/viewPosts")
	public String visualizarPaginaPosts(Model model) {	
    	model.addAttribute("posts",this.getPosts());
    	logger.info("REQUEST: /viewPosts - METHOD: visualizarPaginaPosts() - INFO: Se agregan al contexto de la aplicación la colección de posts");
    	for(Post p:this.getPosts()) {
    		logger.info(p.toString());
    	}
    	logger.info("REQUEST: /viewPosts - METHOD: visualizarPaginaPosts() - INFO: Se solicita la página post.html");
    	return "posts";
	}
	
    @GetMapping("/viewPost")
	public ModelAndView visualizarPaginaPost(@RequestParam(name = "id") int id) {
    	
    	ModelAndView modelAndView = new ModelAndView("post");
    	
    	/*Post p = new Post();
    	for(Post p1:this.getPosts()) {
    		if(p1.getId() == id) {
    			p.setDescripcion(p1.getDescripcion());
    			p.setFecha(p1.getFecha());
    			p.setTitulo(p1.getTitulo());
    			p.setUriImagen(p1.getUriImagen());
    		}
    	}*/
    	
    	Optional<Post> p = this.getPosts().stream().filter(post -> id == post.getId()).findFirst();
    	
    	modelAndView.addObject("post", p.get());
    	
		return modelAndView;
	}
}
